/*
**  InitCode_Core0.h
**
**  Configures the SC58x initcode EXE via the presence or absence
**  of macro #defines in this header.
**
**  Copyright (c) 2011-2013 Analog Devices, Inc. All Rights Reserved.
**
******************************************************************
**/

#ifndef __INITCODE_CORE0_H__
#define __INITCODE_CORE0_H__


#if defined(__ADSPSC57x__)
#include "cdefSC573.h"
#include <cdefSC57x_rom_otpLayout.h>
#include <cdefSC57x_rom.h>
#include <defSC57x_rom_jumptable.h>
#include <defSC57x_rom.h>
#include "sysreg.h"
#include "math.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"
#include "string.h"
#include "builtins.h"
#include <sys/platform.h>
#include <sys/adi_core.h>
#include "CGUInit.h"
#include "DMCInit.h"



#else
#error "Expected target processor ADSP-BF707"
#endif



#define CLKIN_Hz              25000000  /* CLKIN [Hz]   */
#define CLKIN_ns (1000000000/CLKIN_Hz)  /* CLKIN [ns]   */

#define DMC_CTL_VALUE 		0x00000404
#define DMC_CFG_VALUE 		0x00000522
#define DMC_TR0_VALUE 		0x21610535
#define DMC_TR1_VALUE 		0x404E0C30
#define DMC_TR2_VALUE 		0x00326312
#define DMC_MR0_VALUE		0x00000A52
#define DMC_MR1_VALUE 		0x00000004
#define DMC_MR2_VALUE 		0x00000000
#define DMC_PADCTL2_VALUE 	0x0078283C
#define DMC_CPHYCTL_VALUE   0x00000000
#define DMC0_DATA_CALIB_ADD 0x80000000
/*
** CGU initialization is activated by default
**
** To deactivate, comment out the __CONFIG_CGU__ #define below
*/
#define __CONFIG_CGU__

/*
** DDR2 memory initialization is activated by default
**
** To deactivate, comment out the __CONFIG_MEMORY__ #define below
*/
#define __CONFIG_MEMORY__

/*
* For Boot from SPI memory,this definition will modify the SPI_BAUD
* register value and can in/decrease boot speed
*
* Boot ROM default: 0x1F
*
*/

//#define __CHANGE_SPI_BAUD__

#ifdef __CHANGE_SPI_BAUD__
	#define SPI_BAUD_VAL      0x1  /* SPI Clock max is 50MHz. */
#endif


/* Add your custom header content here */

#endif /* __INITCODE_CORE0_H__ */
